;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Document name: loop.pro
; Created by:    Philip Judge, March 28, 2004
;
; Last Modified: Wed May 24 13:10:39 2006 by judge (judge) on edlen.local
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
@cdiper
COMMON therm,temp,tot
common another, ev
COMMON files,lu
;
; Pikaia parameters
;
pop = 120
generation = 500
;creep = 1
decimal = 5

;pop=pop/3
;generation=generation/20

diper,regim=0,approx=1

;
; choose pressures
;
ip = [15,16]
;
; atomic data files
;
atoms=[1,2,6,7,8,10]
;atoms=reverse(atoms)
ttime = systime(1)
FOR ipress = 0,n_elements(ip)-1 DO BEGIN 
   p = 10.^ip(ipress)
;
; Output file
;
   sp = string(ip(ipress),form = '(i2)')
   openw,lu,/get,'lfitpar'+sp+'.dat'
   printf,lu,'*'
   printf,lu,'* Written ',systime(0)
   printf,lu,'* parameters for power radiated in each line per electron per ion, ='
   printf,lu,'* 8.63e-06*(O/temp^P*exp(-ee*E/k/temp)*ee*E +'
   printf,lu,'*  in units of erg cm^3/s'
   printf,lu,'*'
   printf,lu,'*  O is (collision strength/g) -like, Eis energy in eV, P is power of temp' 
   printf,lu,'*  T=0 :a line transition'
   printf,lu,'*  T=1 :total emission from all lines of the ion'
   printf,lu,'*  examples:  A=2, sp=2: He II, A=6, sp=4: C IV etc.'
   printf,lu,'*  Tmn and Tmx are log10 minimum and maximum temperatures of the fit'
   printf,lu,'*  (probably the fits can be used outside of this range)'
   printf,lu,'*  err= rms value of log10(fitted)-log10(actual) power'
   printf,lu,'*'
   printf,lu,'* calculations done for an electron pressure p=nT (cm^-3 K) of:'
   printf,lu,p,form = '(2x,E10.3)'
   printf,lu,'*A  Sp  T  Itran lambda    A        Tmn  Tmx    O          E          P        Err'
   print , '*A  Sp  T  Itran lambda    A        Tmn  Tmx    O          E          P        Err'

   FOR ii = 0,n_elements(atoms)-1 DO BEGIN 
      lowest=2 
      if(atoms(ii) le 2) then lowest=1
      for ion=lowest,atoms(ii) do begin 
      diprd,atoms(ii),ion,/noch
      ato = atomn(atom.atomid)
      imin = min(lvl.ion)
      err = 0
      bad = where(lvl.ion gt imin,nbad)
      if(nbad gt 0) then       level,del = bad
      minn=min(lvl.n)
;
; temperature grid etc
;
      n = 10
      diff = ato-imin
;            
;  h,he, ne, ar-like
;
      range = [-1.,1.5] 
      extra=1 ; only allow delta n le 1 from ground
      IF(diff EQ 0 OR diff EQ 1 OR diff EQ 8 OR diff EQ 10 OR diff EQ 18) THEN begin 
         range = [-0.3,1.5] 
         extra=2  ; allow delta n=1,2
      endif   
      bad = where(lvl.n gt (minn+extra),nbad)
      if(nbad gt 0) then level,del = bad
      z2 = imin*imin
      t = 1.e4*z2
      tg = range(0) + findgen(n)/(n - 1)*(range(1)-range(0))
      temp = t*10.^tg
      nne = p/temp
      sesolv,temp,nne,pops,elc,itmx = 1
      tot = temp*0.
      t1 = total(pops,1)
      ttime = systime(1)
      done=intarr(atom.nline)*0
      print,'nline',atom.nline
      FOR kr = 0,atom.nline -1 DO BEGIN
         jr = trn(kr).jrad
         if(done(kr) eq 1) then goto, skipity
         done(kr)=1
         w=trn(kr).alamb
         share=where(trn.jrad eq jr,num)
         br=1.
         mx=0
         if(num gt 1) then begin
;            print,'number shared=',num
            done(share)=1
            br=trn(kr).a/total(trn(share).a)
            mx=max(trn(share).a)  ; maximum of all transitions w/common upper level
            mx=!c
         endif   
;
         mkr=share(mx)
         tot = reform(pops(jr,*)*hh*cc*1.e8/trn(mkr).alamb*trn(mkr).a)
         tot = tot/t1/nne
         ev=lvl(jr).ev
;         print,ev
         pikaia,'cfit3',3,alpha,fitness,pop=pop,generation=generation,$
                decimal = decimal,creep = creep,muteprob=muteprob
         plot,temp,tot,/xlog,/ylog
         x=cfit3(3,alpha,/plot,parms = parms)
         form1 = '(3(1x,e9.2),3(1x,f9.4),1(1x,f7.3))'
         legend,/top,/left,string(parms,form = form1)

         tt = alog10([min(temp),max(temp)])
         t = 0
         form = '(I3,I3,I3,1x,i4,1x,f11.2,1x,e9.2,2(1x,f4.1),1x,e9.2,3(1x,f9.3))'
         for ir=0,num-1 do begin 
            krr=share(ir)
            w=trn(krr).alamb

            par=parms

            par(0)=par(0) * trn(krr).a/trn(krr).alamb/(trn(mkr).a/trn(mkr).alamb)

            printf,lu,ato,imin,t,krr,w,trn(krr).a,tt,par,form = form
            print   ,ato,imin,t,krr,w,trn(krr).a,tt,par,form = form

         endfor
;         str='' & read,str
         skipity:
         endfor
         print,'elapsed ',systime(1)-ttime
      ENDFOR
   ENDFOR
   free_lun,lu
ENDFOR ; pressures
END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; End of 'loop.pro'.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
